package com.prizm.gateway;

import com.google.gson.Gson;
import com.prizm.gateway.type.PrizmPayAddress;
import com.prizm.gateway.type.PrizmPayData;
import com.prizm.gateway.type.PrizmPayItem;

public class PrizmPayClient_PP {

	String url;
	
	String mid;
	
	String key;
	
	PrizmPayData data = new PrizmPayData();
	
	public PrizmPayClient_PP(String url, String mid, String key) {
		this.url = url;
		this.mid = mid;
		this.key = key;
	}
	
	public void setReferenceCode(String merchant_referenceCode) {
		data.setMerchant_referenceCode(merchant_referenceCode);
	}
	
	public void setInvoiceID(String merchant_invoiceId) {
		data.setMerchant_invoiceId(merchant_invoiceId);
	}
	
	public void addItem(PrizmPayItem item) {
		data.getItem().add(item);
	}
	
	public void setGrandTotal(String purchaseTotals_grandTotalAmount, String purchaseTotals_currency) {
		data.setPurchaseTotals_grandTotalAmount(purchaseTotals_grandTotalAmount);
		data.setPurchaseTotals_currency(purchaseTotals_currency.toUpperCase());
	}
	
	public void setBillingAddressArray(PrizmPayAddress billTo) {
		data.setBillTo(billTo);
	}
	
	public void setShippingAddressArray(PrizmPayAddress shipTo) {
		data.setShipTo(shipTo);
	}
	
	private String json_encode(Object obj) {
		Gson gson = new Gson();
		String json = gson.toJson(obj);
		return json;
	}
	
	public String html(boolean autoSubmit) {
		
		// json encode data
		String jsonData = json_encode(data);

        // get current unix timestamp
        long unixTimestamp = System.currentTimeMillis() / 1000;
        
        // make secret hash
        String secretHash = PrizmPayClient.secretHash(mid, key, jsonData, unixTimestamp);

        // make url
        String targetURL = this.url + "/pay?mid=" + this.mid + "&time=" + unixTimestamp + "&hash=" + secretHash;

        // create html form
        String html = "<form id='form' name='form' method='post' action='" + targetURL + "'>";

        html += PrizmPayFormHelper.hidden_input("data", jsonData) + "\n";

        html += "</form>";

        if (autoSubmit) {
        	// add javascript for auto submit
        	html += "<script>document.getElementById('form').submit();</script>";
        }

        return html;
	}
	
	public String open() {
		return html(true);
	}
}
