package com.prizm.gateway;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.lang3.StringEscapeUtils;

import com.prizm.gateway.type.PrizmPayAddress;
import com.prizm.gateway.type.PrizmPayItem;

public class PrizmPayFormHelper {
	
	HttpServletRequest request;
	
	public PrizmPayFormHelper(HttpServletRequest request) {
		this.request = request;
	}
	
	public String getString(String key) {
		String value = request.getParameter(key);
		return value == null ? "" : value;
	}
	
	public int getInteger(String key) {
		String value = request.getParameter(key);
		return (value != null && value.length() > 0) ? Integer.parseInt(value) : 0;
	}
	
	public double getDouble(String key) {
		String value = request.getParameter(key);
		return (value != null && value.length() > 0) ? Double.parseDouble(value) : 0;
	}
	
	public PrizmPayItem getItem(int i) {
		PrizmPayItem item = null;
		if (request.getParameter("item[" + i + "][name]") != null && request.getParameter("item[" + i + "][name]").length() > 0) {
			item = new PrizmPayItem(
				getString("item[" + i + "][name]"), 
				getString("item[" + i + "][quantity]"), 
				getString("item[" + i + "][unitPrice]"));
		}
		return item;
	}
	
	public PrizmPayAddress getAddress(String type) {
		PrizmPayAddress address = null;
		if (getString(type + "[firstName]") != null) {
			address = new PrizmPayAddress();
			address.setFirstName(getString(type + "[firstName]"));
			address.setLastName(getString(type + "[lastName]"));
			address.setEmail(getString(type + "[email]"));
			address.setPhoneNumber(getString(type + "[phoneNumber]"));
			address.setStreet1(getString(type + "[street1]"));
			address.setStreet2(getString(type + "[street2]"));
			address.setCity(getString(type + "[city]"));
			address.setState(getString(type + "[state]"));
			address.setCountry(getString(type + "[country]"));
			address.setPostalCode(getString(type + "[postalCode]"));
		}
		return address;
	}

	public static String escape(String str) {
		return StringEscapeUtils.escapeHtml3(str);
	}
	
	public static String hidden_input(String name, String value) {
		if (value == null)
			return "";
		
		return "<input type='hidden' name='" + PrizmPayFormHelper.escape(name) + "' value='" + PrizmPayFormHelper.escape(value) + "' />";
	}
	
}
